diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/msdu-aggregator.cc ns-3.34/src/wifi/model/msdu-aggregator.cc
--- ns-3.33/src/wifi/model/msdu-aggregator.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/msdu-aggregator.cc	2021-07-14 10:31:07.000000000 -0700
@@ -22,17 +22,14 @@
 #include "ns3/log.h"
 #include "ns3/packet.h"
 #include "msdu-aggregator.h"
-#include "amsdu-subframe-header.h"
 #include "qos-txop.h"
-#include "mpdu-aggregator.h"
 #include "wifi-remote-station-manager.h"
-#include "mac-low.h"
-#include "wifi-phy.h"
-#include "wifi-net-device.h"
-#include "ht-capabilities.h"
-#include "wifi-mac.h"
+#include "ns3/ht-capabilities.h"
+#include "regular-wifi-mac.h"
 #include "wifi-mac-queue.h"
 #include "wifi-mac-trailer.h"
+#include "ns3/ht-frame-exchange-manager.h"
+#include "wifi-tx-parameters.h"
 #include <algorithm>
 
 namespace ns3 {
@@ -61,9 +58,19 @@
 }
 
 void
-MsduAggregator::SetEdcaQueues (EdcaQueues map)
+MsduAggregator::DoDispose ()
 {
-    m_edca = map;
+  m_mac = 0;
+  m_htFem = 0;
+  Object::DoDispose ();
+}
+
+void
+MsduAggregator::SetWifiMac (const Ptr<RegularWifiMac> mac)
+{
+  NS_LOG_FUNCTION (this << mac);
+  m_mac = mac;
+  m_htFem = DynamicCast<HtFrameExchangeManager> (m_mac->GetFrameExchangeManager ());
 }
 
 uint16_t
@@ -76,27 +83,24 @@
 }
 
 Ptr<WifiMacQueueItem>
-MsduAggregator::GetNextAmsdu (Mac48Address recipient, uint8_t tid,
-                              WifiTxVector txVector, uint32_t ampduSize,
-                              Time ppduDurationLimit) const
+MsduAggregator::GetNextAmsdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
+                              Time availableTime, WifiMacQueueItem::QueueIteratorPair& queueIt) const
 {
-  NS_LOG_FUNCTION (recipient << +tid << txVector << ampduSize << ppduDurationLimit);
+  NS_LOG_FUNCTION (this << *peekedItem << &txParams << availableTime);
+
+  NS_ASSERT (peekedItem->IsQueued ());
+  NS_ASSERT (peekedItem->GetQueueIteratorPairs ().size () == 1);
+  WifiMacQueueItem::QueueIteratorPair peekedIt = peekedItem->GetQueueIteratorPairs ().front ();
+  NS_ASSERT ((*peekedIt.it)->GetPacket () == peekedItem->GetPacket ());
+
+  uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
+  Mac48Address recipient = peekedItem->GetHeader ().GetAddr1 ();
 
   /* "The Address 1 field of an MPDU carrying an A-MSDU shall be set to an
    * individual address or to the GCR concealment address" (Section 10.12
    * of 802.11-2016)
    */
-  NS_ABORT_MSG_IF (recipient.IsGroup (), "Recipient address is group addressed");
-
-  Ptr<QosTxop> qosTxop = m_edca.find (QosUtilsMapTidToAc (tid))->second;
-  Ptr<WifiMacQueue> queue = qosTxop->GetWifiMacQueue ();
-  WifiMacQueue::ConstIterator peekedIt = queue->PeekByTidAndAddress (tid, recipient);
-
-  if (peekedIt == queue->end ())
-    {
-      NS_LOG_DEBUG ("No packet with the given TID and address in the queue");
-      return 0;
-    }
+  NS_ABORT_MSG_IF (recipient.IsBroadcast (), "Recipient address is broadcast");
 
   /* "A STA shall not transmit an A-MSDU within a QoS Data frame under a block
    * ack agreement unless the recipient indicates support for A-MSDU by setting
@@ -105,74 +109,38 @@
    */
   // No check required for now, as we always set the A-MSDU Supported field to 1
 
-  WifiModulationClass modulation = txVector.GetMode ().GetModulationClass ();
+  // TODO Add support for the Max Number Of MSDUs In A-MSDU field in the Extended
+  // Capabilities element sent by the recipient
 
-  // Get the maximum size of the A-MSDU we can send to the recipient
-  uint16_t maxAmsduSize = GetMaxAmsduSize (recipient, tid, modulation);
+  NS_ASSERT (m_htFem != 0);
 
-  if (maxAmsduSize == 0)
+  if (GetMaxAmsduSize (recipient, tid, txParams.m_txVector.GetModulationClass ()) == 0)
     {
-      return 0;
+      NS_LOG_DEBUG ("A-MSDU aggregation disabled");
+      return nullptr;
     }
 
-  Ptr<WifiMacQueueItem> amsdu = Create<WifiMacQueueItem> (Create<const Packet> (), (*peekedIt)->GetHeader ());
-  uint8_t nMsdu = 0;
-  // We need to keep track of the first MSDU. When it is processed, it is not known
-  // if aggregation will succeed or not.
-  WifiMacQueue::ConstIterator first = peekedIt;
+  Ptr<WifiMacQueueItem> amsdu = Copy (peekedItem);
+  uint8_t nMsdu = 1;
 
-  // TODO Add support for the Max Number Of MSDUs In A-MSDU field in the Extended
-  // Capabilities element sent by the recipient
+  peekedIt.it++;
 
-  while (peekedIt != queue->end ())
+  while ((peekedIt.it = peekedIt.queue->PeekByTidAndAddress (tid, recipient, peekedIt.it)) != peekedIt.queue->end ()
+         && m_htFem->TryAggregateMsdu (*peekedIt.it, txParams, availableTime))
     {
-      // check if aggregating the peeked MSDU violates the A-MSDU size limit
-      uint16_t newAmsduSize = GetSizeIfAggregated ((*peekedIt)->GetPacket ()->GetSize (),
-                                                   amsdu->GetPacket ()->GetSize ());
-
-      if (newAmsduSize > maxAmsduSize)
-        {
-          NS_LOG_DEBUG ("No other MSDU can be aggregated: maximum A-MSDU size reached");
-          break;
-        }
-
-      // check if the A-MSDU obtained by aggregating the peeked MSDU violates
-      // the A-MPDU size limit or the PPDU duration limit
-      if (!qosTxop->GetLow ()->IsWithinSizeAndTimeLimits (amsdu->GetHeader ().GetSize () + newAmsduSize
-                                                          + WIFI_MAC_FCS_LENGTH,
-                                                          recipient, tid, txVector, ampduSize, ppduDurationLimit))
-        {
-          NS_LOG_DEBUG ("No other MSDU can be aggregated");
-          break;
-        }
-
-      // The MSDU can be aggregated to the A-MSDU.
-      // If it is the first MSDU, move to the next one
-      if (nMsdu == 0)
-        {
-          amsdu = Copy (*peekedIt);
-          peekedIt++;
-        }
-      // otherwise, remove it from the queue
-      else
-        {
-          amsdu->Aggregate (*peekedIt);
-          peekedIt = queue->Remove (peekedIt);
-        }
-
+      amsdu->Aggregate (*peekedIt.it);
+      peekedIt.it++;
       nMsdu++;
-
-      peekedIt = queue->PeekByTidAndAddress (tid, recipient, peekedIt);
     }
 
-  if (nMsdu < 2)
+  if (nMsdu == 1)
     {
       NS_LOG_DEBUG ("Aggregation failed (could not aggregate at least two MSDUs)");
-      return 0;
+      return nullptr;
     }
 
-  // Aggregation succeeded, we have to remove the first MSDU
-  queue->Remove (first);
+  // Aggregation succeeded
+  queueIt = peekedIt;
 
   return amsdu;
 }
@@ -190,11 +158,6 @@
   NS_LOG_FUNCTION (this << recipient << +tid << modulation);
 
   AcIndex ac = QosUtilsMapTidToAc (tid);
-  Ptr<QosTxop> qosTxop = m_edca.find (ac)->second;
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (qosTxop->GetLow ()->GetPhy ()->GetDevice ());
-  NS_ASSERT (device);
-  Ptr<WifiRemoteStationManager> stationManager = device->GetRemoteStationManager ();
-  NS_ASSERT (stationManager);
 
   // Find the A-MSDU max size configured on this device
   UintegerValue size;
@@ -202,16 +165,16 @@
   switch (ac)
     {
       case AC_BE:
-        device->GetMac ()->GetAttribute ("BE_MaxAmsduSize", size);
+        m_mac->GetAttribute ("BE_MaxAmsduSize", size);
         break;
       case AC_BK:
-        device->GetMac ()->GetAttribute ("BK_MaxAmsduSize", size);
+        m_mac->GetAttribute ("BK_MaxAmsduSize", size);
         break;
       case AC_VI:
-        device->GetMac ()->GetAttribute ("VI_MaxAmsduSize", size);
+        m_mac->GetAttribute ("VI_MaxAmsduSize", size);
         break;
       case AC_VO:
-        device->GetMac ()->GetAttribute ("VO_MaxAmsduSize", size);
+        m_mac->GetAttribute ("VO_MaxAmsduSize", size);
         break;
       default:
         NS_ABORT_MSG ("Unknown AC " << ac);
@@ -226,6 +189,9 @@
       return 0;
     }
 
+  Ptr<WifiRemoteStationManager> stationManager = m_mac->GetWifiRemoteStationManager ();
+  NS_ASSERT (stationManager);
+
   // Retrieve the Capabilities elements advertised by the recipient
   Ptr<const VhtCapabilities> vhtCapabilities = stationManager->GetStationVhtCapabilities (recipient);
   Ptr<const HtCapabilities> htCapabilities = stationManager->GetStationHtCapabilities (recipient);
@@ -271,11 +237,11 @@
   return maxAmsduSize;
 }
 
-MsduAggregator::DeaggregatedMsdus
+WifiMacQueueItem::DeaggregatedMsdus
 MsduAggregator::Deaggregate (Ptr<Packet> aggregatedPacket)
 {
   NS_LOG_FUNCTION_NOARGS ();
-  DeaggregatedMsdus set;
+  WifiMacQueueItem::DeaggregatedMsdus set;
 
   AmsduSubframeHeader hdr;
   Ptr<Packet> extractedMsdu = Create<Packet> ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/msdu-aggregator.h ns-3.34/src/wifi/model/msdu-aggregator.h
--- ns-3.33/src/wifi/model/msdu-aggregator.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/msdu-aggregator.h	2021-07-14 10:31:07.000000000 -0700
@@ -25,15 +25,17 @@
 #include "ns3/nstime.h"
 #include "wifi-mode.h"
 #include "qos-utils.h"
+#include "wifi-mac-queue-item.h"
 #include <map>
 
 namespace ns3 {
 
-class AmsduSubframeHeader;
 class Packet;
 class QosTxop;
-class WifiMacQueueItem;
 class WifiTxVector;
+class RegularWifiMac;
+class HtFrameExchangeManager;
+class WifiTxParameters;
 
 /**
  * \brief Aggregator used to construct A-MSDUs
@@ -42,10 +44,6 @@
 class MsduAggregator : public Object
 {
 public:
-  /// DeaggregatedMsdus typedef
-  typedef std::list<std::pair<Ptr<const Packet>, AmsduSubframeHeader> > DeaggregatedMsdus;
-  /// DeaggregatedMsdusCI typedef
-  typedef std::list<std::pair<Ptr<const Packet>, AmsduSubframeHeader> >::const_iterator DeaggregatedMsdusCI;
   /// EDCA queues typedef
   typedef std::map<AcIndex, Ptr<QosTxop> > EdcaQueues;
 
@@ -71,36 +69,38 @@
   static uint16_t GetSizeIfAggregated (uint16_t msduSize, uint16_t amsduSize);
 
   /**
-   * Dequeue MSDUs to be transmitted to a given station and belonging to a
-   * given TID from the corresponding EDCA queue and aggregate them to form
-   * an A-MSDU that meets the following constraints:
+   * Attempt to aggregate other MSDUs to the given A-MSDU while meeting the
+   * following constraints:
    *
    * - the A-MSDU size does not exceed the maximum A-MSDU size as determined for
    * the modulation class indicated by the given TxVector
    *
    * - the size of the A-MPDU resulting from the aggregation of the MPDU in which
-   * the A-MSDU will be embedded and an existing A-MPDU of the given size
-   * (possibly null) does not exceed the maximum A-MPDU size as determined for
+   * the A-MSDU will be embedded and the current A-MPDU (as specified by the given
+   * TX parameters) does not exceed the maximum A-MPDU size as determined for
    * the modulation class indicated by the given TxVector
    *
    * - the time to transmit the resulting PPDU, according to the given TxVector,
-   * does not exceed both the maximum PPDU duration allowed by the corresponding
-   * modulation class (if any) and the given PPDU duration limit (if distinct from
-   * Time::Min ())
+   * does not exceed the maximum PPDU duration allowed by the corresponding
+   * modulation class (if any)
+   *
+   * - the time to transmit the resulting PPDU and to carry out protection and
+   * acknowledgment, as specified by the given TX parameters, does not exceed the
+   * given available time (if distinct from Time::Min ())
    *
    * If it is not possible to aggregate at least two MSDUs, no MSDU is dequeued
    * from the EDCA queue and a null pointer is returned.
    *
-   * \param recipient the receiver station address.
-   * \param tid the TID.
-   * \param txVector the TxVector used to transmit the frame
-   * \param ampduSize the size of the existing A-MPDU in bytes
-   * \param ppduDurationLimit the limit on the PPDU duration
-   * \return the resulting A-MSDU, if aggregation is possible, 0 otherwise.
-   */
-  Ptr<WifiMacQueueItem> GetNextAmsdu (Mac48Address recipient, uint8_t tid,
-                                      WifiTxVector txVector, uint32_t ampduSize = 0,
-                                      Time ppduDurationLimit = Time::Min ()) const;
+   * \param peekedItem the MSDU which we attempt to aggregate other MSDUs to
+   * \param txParams the TX parameters for the current frame
+   * \param availableTime the time available for the frame exchange
+   * \param[out] queueIt a QueueIteratorPair pointing to the queue item following the
+   *                     last item used to prepare the returned A-MSDU, if any; otherwise,
+   *                     its value is unchanged
+   * \return the resulting A-MSDU, if aggregation is possible, a null pointer otherwise.
+   */
+  Ptr<WifiMacQueueItem> GetNextAmsdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
+                                      Time availableTime, WifiMacQueueItem::QueueIteratorPair& queueIt) const;
 
   /**
    * Determine the maximum size for an A-MSDU of the given TID that can be sent
@@ -119,14 +119,14 @@
    * \param aggregatedPacket the aggregated packet.
    * \returns DeaggregatedMsdus.
    */
-  static DeaggregatedMsdus Deaggregate (Ptr<Packet> aggregatedPacket);
+  static WifiMacQueueItem::DeaggregatedMsdus Deaggregate (Ptr<Packet> aggregatedPacket);
 
   /**
-   * Set the map of EDCA queues.
+   * Set the MAC layer to use.
    *
-   * \param map the map of EDCA queues.
+   * \param mac the MAC layer to use
    */
-  void SetEdcaQueues (EdcaQueues map);
+  void SetWifiMac (const Ptr<RegularWifiMac> mac);
 
   /**
    * Calculate how much padding must be added to the end of an A-MSDU of the
@@ -139,8 +139,12 @@
    */
   static uint8_t CalculatePadding (uint16_t amsduSize);
 
+protected:
+  void DoDispose () override;
+
 private:
-  EdcaQueues m_edca;   //!< the map of EDCA queues
+  Ptr<RegularWifiMac> m_mac;            //!< the MAC of this station
+  Ptr<HtFrameExchangeManager> m_htFem;  //!< the HT Frame Exchange Manager of this station
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/nist-error-rate-model.cc ns-3.34/src/wifi/model/nist-error-rate-model.cc
--- ns-3.33/src/wifi/model/nist-error-rate-model.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/nist-error-rate-model.cc	2021-07-14 10:31:07.000000000 -0700
@@ -217,9 +217,9 @@
 }
 
 double
-NistErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const
+NistErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits, uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const
 {
-  NS_LOG_FUNCTION (this << mode << snr << nbits);
+  NS_LOG_FUNCTION (this << mode << snr << nbits << +numRxAntennas << field << staId);
   if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM
       || mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM
       || mode.GetModulationClass () == WIFI_MOD_CLASS_HT
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/nist-error-rate-model.h ns-3.34/src/wifi/model/nist-error-rate-model.h
--- ns-3.33/src/wifi/model/nist-error-rate-model.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/nist-error-rate-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -47,8 +47,8 @@
 
 
 private:
-  //Inherited from ErrorRateModel
-  double DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const;
+  double DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits,
+                                uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const override;
   /**
    * Return the bValue such that coding rate = bValue / (bValue + 1).
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-error-rate-model.cc ns-3.34/src/wifi/model/non-ht/dsss-error-rate-model.cc
--- ns-3.33/src/wifi/model/non-ht/dsss-error-rate-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-error-rate-model.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,175 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2010 The Boeing Company
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Gary Pei <guangyu.pei@boeing.com>
+ */
+
+#include "ns3/log.h"
+#include "dsss-error-rate-model.h"
+#include <cmath>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("DsssErrorRateModel");
+
+#ifndef HAVE_GSL
+const double DsssErrorRateModel::WLAN_SIR_PERFECT = 10.0;
+const double DsssErrorRateModel::WLAN_SIR_IMPOSSIBLE = 0.1;
+#endif
+
+double
+DsssErrorRateModel::DqpskFunction (double x)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+  return ((std::sqrt (2.0) + 1.0) / std::sqrt (8.0 * M_PI * std::sqrt (2.0)))
+         * (1.0 / std::sqrt (x)) * std::exp ( -(2.0 - std::sqrt (2.0)) * x);
+}
+
+double
+DsssErrorRateModel::GetDsssDbpskSuccessRate (double sinr, uint64_t nbits)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+  double EbN0 = sinr * 22000000.0 / 1000000.0; //1 bit per symbol with 1 MSPS
+  double ber = 0.5 * std::exp (-EbN0);
+  return std::pow ((1.0 - ber), static_cast<double> (nbits));
+}
+
+double
+DsssErrorRateModel::GetDsssDqpskSuccessRate (double sinr, uint64_t nbits)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+  double EbN0 = sinr * 22000000.0 / 1000000.0 / 2.0; //2 bits per symbol, 1 MSPS
+  double ber = DqpskFunction (EbN0);
+  return std::pow ((1.0 - ber), static_cast<double> (nbits));
+}
+
+double
+DsssErrorRateModel::GetDsssDqpskCck5_5SuccessRate (double sinr, uint64_t nbits)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+#ifdef HAVE_GSL
+  //symbol error probability
+  double EbN0 = sinr * 22000000.0 / 1375000.0 / 4.0;
+  double sep = SymbolErrorProb16Cck (4.0 * EbN0 / 2.0);
+  return std::min (1.0, std::pow (1.0 - sep, nbits / 4.0));
+#else
+  NS_LOG_WARN ("Running a 802.11b CCK Matlab model less accurate than GSL model");
+  //The Matlab model
+  double ber;
+  if (sinr > WLAN_SIR_PERFECT)
+    {
+      ber = 0.0;
+    }
+  else if (sinr < WLAN_SIR_IMPOSSIBLE)
+    {
+      ber = 0.5;
+    }
+  else
+    {
+      //fitprops.coeff from Matlab berfit
+      double a1 = 5.3681634344056195e-001;
+      double a2 = 3.3092430025608586e-003;
+      double a3 = 4.1654372361004000e-001;
+      double a4 = 1.0288981434358866e+000;
+      ber = a1 * std::exp (-std::pow ((sinr - a2) / a3, a4));
+    }
+  return std::min (1.0, std::pow ((1.0 - ber), static_cast<double> (nbits)));
+#endif
+}
+
+double
+DsssErrorRateModel::GetDsssDqpskCck11SuccessRate (double sinr, uint64_t nbits)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+#ifdef HAVE_GSL
+  NS_LOG_DEBUG ("GSL enabled ");
+  //symbol error probability
+  double EbN0 = sinr * 22000000.0 / 1375000.0 / 8.0;
+  double sep = SymbolErrorProb256Cck (8.0 * EbN0 / 2.0);
+  return std::min (1.0, std::pow (1.0 - sep, nbits / 8.0));
+#else
+  NS_LOG_WARN ("Running a 802.11b CCK Matlab model less accurate than GSL model");
+  //The Matlab model
+  double ber;
+  if (sinr > WLAN_SIR_PERFECT)
+    {
+      ber = 0.0;
+    }
+  else if (sinr < WLAN_SIR_IMPOSSIBLE)
+    {
+      ber = 0.5;
+    }
+  else
+    {
+      //fitprops.coeff from Matlab berfit
+      double a1 = 7.9056742265333456e-003;
+      double a2 = -1.8397449399176360e-001;
+      double a3 = 1.0740689468707241e+000;
+      double a4 = 1.0523316904502553e+000;
+      double a5 = 3.0552298746496687e-001;
+      double a6 = 2.2032715128698435e+000;
+      ber =  (a1 * sinr * sinr + a2 * sinr + a3) / (sinr * sinr * sinr + a4 * sinr * sinr + a5 * sinr + a6);
+    }
+  return std::min (1.0, std::pow ((1.0 - ber), static_cast<double> (nbits)));
+#endif
+}
+
+#ifdef HAVE_GSL
+double
+IntegralFunction (double x, void *params)
+{
+  double beta = ((FunctionParameters *) params)->beta;
+  double n = ((FunctionParameters *) params)->n;
+  double IntegralFunction = std::pow (2 * gsl_cdf_ugaussian_P (x + beta) - 1, n - 1)
+    * std::exp (-x * x / 2.0) / std::sqrt (2.0 * M_PI);
+  return IntegralFunction;
+}
+
+double
+DsssErrorRateModel::SymbolErrorProb16Cck (double e2)
+{
+  double sep;
+  double error;
+
+  FunctionParameters params;
+  params.beta = std::sqrt (2.0 * e2);
+  params.n = 8.0;
+
+  gsl_integration_workspace * w = gsl_integration_workspace_alloc (1000);
+
+  gsl_function F;
+  F.function = &IntegralFunction;
+  F.params = &params;
+
+  gsl_integration_qagiu (&F,-params.beta, 0, 1e-7, 1000, w, &sep, &error);
+  gsl_integration_workspace_free (w);
+  if (error == 0.0)
+    {
+      sep = 1.0;
+    }
+
+  return 1.0 - sep;
+}
+
+double DsssErrorRateModel::SymbolErrorProb256Cck (double e1)
+{
+  return 1.0 - std::pow (1.0 - SymbolErrorProb16Cck (e1 / 2.0), 2.0);
+}
+
+#endif
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-error-rate-model.h ns-3.34/src/wifi/model/non-ht/dsss-error-rate-model.h
--- ns-3.33/src/wifi/model/non-ht/dsss-error-rate-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-error-rate-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,142 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2010 The Boeing Company
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Gary Pei <guangyu.pei@boeing.com>
+ */
+
+#ifndef DSSS_ERROR_RATE_MODEL_H
+#define DSSS_ERROR_RATE_MODEL_H
+
+#ifdef HAVE_GSL
+#include <gsl/gsl_math.h>
+#include <gsl/gsl_integration.h>
+#include <gsl/gsl_cdf.h>
+#include <gsl/gsl_sf_bessel.h>
+#endif
+
+namespace ns3 {
+
+#ifdef HAVE_GSL
+/**
+ * Structure for integral function parameters
+ */
+typedef struct FunctionParameterType
+{
+  double beta; ///< Beta parameter
+  double n;    ///< n parameter
+} FunctionParameters;
+
+/**
+ * Integral function using GSL library
+ *
+ * \param x the input x variable
+ * \param params a pointer to FunctionParameters struct
+ *
+ * \return the integral function
+ */
+double IntegralFunction (double x, void *params);
+#endif
+
+/**
+ * \brief an implementation of DSSS error rate model
+ * \ingroup wifi
+ *
+ * The 802.11b modulations:
+ *    - 1 Mbps mode is based on DBPSK. BER is from equation 5.2-69 from John G. Proakis
+ *      Digital Communications, 2001 edition
+ *    - 2 Mbps model is based on DQPSK. Equation 8 from "Tight bounds and accurate
+ *      approximations for DQPSK transmission bit error rate", G. Ferrari and G.E. Corazza
+ *      ELECTRONICS LETTERS, 40(20):1284-1285, September 2004
+ *    - 5.5 Mbps and 11 Mbps are based on equations (18) and (17) from "Properties and
+ *      performance of the IEEE 802.11b complementarycode-key signal sets",
+ *      Michael B. Pursley and Thomas C. Royster. IEEE TRANSACTIONS ON COMMUNICATIONS,
+ *      57(2):440-449, February 2009.
+ *
+ *  This model is designed to run with highest accuracy using the GNU
+ *  Scientific Library (GSL), but if GSL is not installed on the platform,
+ *  will fall back to (slightly less accurate) Matlab-derived models for
+ *  the CCK modulation types.
+ *
+ *  More detailed description and validation can be found in
+ *      http://www.nsnam.org/~pei/80211b.pdf
+ */
+class DsssErrorRateModel
+{
+public:
+  /**
+   * A function DQPSK
+   *
+   * \param x the input variable
+   *
+   * \return DQPSK (x)
+   */
+  static double DqpskFunction (double x);
+  /**
+   * Return the chunk success rate of the differential BPSK.
+   *
+   * \param sinr the SINR ratio (not dB) of the chunk
+   * \param nbits the size of the chunk
+   *
+   * \return the chunk success rate of the differential BPSK
+   */
+  static double GetDsssDbpskSuccessRate (double sinr, uint64_t nbits);
+  /**
+   * Return the chunk success rate of the differential encoded QPSK.
+   *
+   * \param sinr the SINR ratio (not dB) of the chunk
+   * \param nbits the size of the chunk
+   *
+   * \return the chunk success rate of the differential encoded QPSK.
+   */
+  static double GetDsssDqpskSuccessRate (double sinr,uint64_t nbits);
+  /**
+   * Return the chunk success rate of the differential encoded QPSK for
+   * 5.5Mbps data rate.
+   *
+   * \param sinr the SINR ratio (not dB) of the chunk
+   * \param nbits the size of the chunk
+   *
+   * \return the chunk success rate of the differential encoded QPSK for
+   */
+  static double GetDsssDqpskCck5_5SuccessRate (double sinr,uint64_t nbits);
+  /**
+   * Return the chunk success rate of the differential encoded QPSK for
+   * 11Mbps data rate.
+   *
+   * \param sinr the SINR ratio (not dB) of the chunk
+   * \param nbits the size of the chunk
+   *
+   * \return the chunk success rate of the differential encoded QPSK for
+   */
+  static double GetDsssDqpskCck11SuccessRate (double sinr,uint64_t nbits);
+#ifdef HAVE_GSL
+  static double SymbolErrorProb16Cck (double e2); /// equation (18) in Pursley's paper
+  static double SymbolErrorProb256Cck (double e1); /// equation (17) in Pursley's paper
+#else
+
+
+protected:
+  /// WLAN perfect
+  static const double WLAN_SIR_PERFECT;
+  /// WLAN impossible
+  static const double WLAN_SIR_IMPOSSIBLE;
+#endif
+};
+
+} //namespace ns3
+
+#endif /* DSSS_ERROR_RATE_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-parameter-set.cc ns-3.34/src/wifi/model/non-ht/dsss-parameter-set.cc
--- ns-3.33/src/wifi/model/non-ht/dsss-parameter-set.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-parameter-set.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,93 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "dsss-parameter-set.h"
+
+namespace ns3 {
+
+DsssParameterSet::DsssParameterSet ()
+  : m_currentChannel (0),
+    m_dsssSupported (0)
+{
+}
+
+WifiInformationElementId
+DsssParameterSet::ElementId () const
+{
+  return IE_DSSS_PARAMETER_SET;
+}
+
+void
+DsssParameterSet::SetDsssSupported (uint8_t dsssSupported)
+{
+  m_dsssSupported = dsssSupported;
+}
+
+void
+DsssParameterSet::SetCurrentChannel (uint8_t currentChannel)
+{
+  m_currentChannel = currentChannel;
+}
+
+uint8_t
+DsssParameterSet::GetInformationFieldSize () const
+{
+  NS_ASSERT (m_dsssSupported);
+  return 1;
+}
+
+Buffer::Iterator
+DsssParameterSet::Serialize (Buffer::Iterator i) const
+{
+  if (!m_dsssSupported)
+    {
+      return i;
+    }
+  return WifiInformationElement::Serialize (i);
+}
+
+uint16_t
+DsssParameterSet::GetSerializedSize () const
+{
+  if (!m_dsssSupported)
+    {
+      return 0;
+    }
+  return WifiInformationElement::GetSerializedSize ();
+}
+
+void
+DsssParameterSet::SerializeInformationField (Buffer::Iterator start) const
+{
+  if (m_dsssSupported)
+    {
+      start.WriteU8 (m_currentChannel);
+    }
+}
+
+uint8_t
+DsssParameterSet::DeserializeInformationField (Buffer::Iterator start, uint8_t length)
+{
+  Buffer::Iterator i = start;
+  m_currentChannel = i.ReadU8 ();
+  return length;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/non-ht/dsss-parameter-set.h ns-3.34/src/wifi/model/non-ht/dsss-parameter-set.h
--- ns-3.33/src/wifi/model/non-ht/dsss-parameter-set.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/non-ht/dsss-parameter-set.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,74 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef DSSS_PARAMETER_SET_H
+#define DSSS_PARAMETER_SET_H
+
+#include "ns3/wifi-information-element.h"
+
+namespace ns3 {
+
+/**
+ * \brief The DSSS Parameter Set
+ * \ingroup wifi
+ *
+ * This class knows how to serialise and deserialise the DSSS Parameter Set.
+ */
+class DsssParameterSet : public WifiInformationElement
+{
+public:
+  DsssParameterSet ();
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length) override;
+  /* This information element is a bit special in that it is only
+     included if the STA does support DSSS. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const override;
+  uint16_t GetSerializedSize () const override;
+
+  /**
+   * Set DSSS supported
+   * \param dsssSupported the DSSS supported indicator
+   */
+  void SetDsssSupported (uint8_t dsssSupported);
+
+  /**
+   * Set the Current Channel field in the DsssParameterSet information element.
+   *
+   * \param currentChannel the CurrentChannel field in the DsssParameterSet information element
+   */
+  void SetCurrentChannel (uint8_t currentChannel);
+
+
+private:
+  uint8_t m_currentChannel; ///< current channel number
+
+  /// This is used to decide whether this element should be added to the frame or not
+  bool m_dsssSupported;
+};
+
+} //namespace ns3
+
+#endif /* DSSS_PARAMETER_SET_H */
